<?php

namespace RxConnexionBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\SystemParameterEntity;

use RxConnexionBundle\Form\SystemParameterForm;

/**
 * @Route("/main/sys_params")
 */
class SystemParameterController extends Controller
{
    /**
     * @Route("/t/{type}",
     *      defaults = {
     *          "type":  ""
     *      },
     *     name="sys_params")
     */
    public function indexAction($type) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin System Parameter'))) return $authService->redirectToHome();

	    $type = empty($type) ? 'System' : $type;
        return $this->render('@RxConnexion/SystemParameter/index.html.twig', array(
            'title'       => "Manage $type Parameter",
            'page_title'  => "Manage $type Parameter",
            'type'        => $type,
            'javascripts' => array('rxconnexion/admin/js/sys_params/sys_params.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="sys_params_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {


            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:SystemParameterEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {
	            $hasUpdate = $authService->isUserHasAccesses(array("Admin {$row['type']} Parameter Update"), false);

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('sys_params_form', array(
                        'action' => 'u',
                        'id'     => $id,
                        'type'   => $row['type'],
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['description'],
                    $row['value'],
                    $row['note'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}/{type}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0,
     *          "type": ""
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "sys_params_form"
     * )
     */
    public function formAction($action, $id, $type, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();

        $type = empty($type) ? 'System' : $type;

        if(!$authService->isUserHasAccesses(array("Admin $type Parameter New", "Admin $type Parameter Update"))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $sysParams = $em->getRepository('RxConnexionBundle:SystemParameterEntity')->find(base64_decode($id));
        if(!$sysParams) {
            $sysParams = new SystemParameterEntity();
        }

        $formOptions = array('action' => $action, 'type' => $type);
        $form = $this->createForm(SystemParameterForm::class, $sysParams, $formOptions);

        if($request->getMethod() === 'POST') {

            $sysParams_form = $request->get($form->getName());
            $result = $this->processForm($sysParams_form, $sysParams, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('sys_params', ['type' => $type]), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('sys_params_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id']),
                        'type' => $type
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('sys_params_form', ['type' => $type]), 302);
                }
            } else {
                $form->submit($sysParams_form, false);
            }
        }

        $title = ($action === 'n' ? 'New ' : 'Update ') . $type . ' Parameter';

        return $this->render('@RxConnexion/SystemParameter/form.html.twig', array(
	        'title'       => $title,
	        'page_title'  => $title,
	        'javascripts' => array('rxconnexion/admin/js/sys_params/sys_params_form.js?v=1.0.0'),
	        'form'        => $form->createView(),
	        'action'      => $action,
	        'id'          => $id,
	        'type'        => $type,
        ));
    }

    private function processForm($sysParams_form, $sysParams, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:SystemParameterEntity')->validate($sysParams_form);

        if(!count($errors)) {

            switch($sysParams_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($sysParams);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'System Parameter',
                            $em->getClassMetadata(SystemParameterEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $sysParams;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'System Parameter',
                        $em->getClassMetadata(SystemParameterEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $sysParams;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'System Parameter',
                        $em->getClassMetadata(SystemParameterEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $sysParams;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($sysParams);
                        $sysParams->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="system_parameter_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:SystemParameterEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}
